DEFine PROCedure make_colours (colourway%)
REMark this initialises the GLOBAL variables menu_pap, menu_brd, menu_inv,
REMark menu_ink and menu_bar according to the colourway passed as parameter.
REMark More importantly, this sets the sp.xxx GLOBAL variables.
REMark The GLOBAl variable mycolour_mode% must have been set prior to calling
REMark this function, preferrably via the function set_colours%.
REMark Moreover the colours black, white,red, green,wg_stripes, etc...
REMark must have been set prior to calling this procedure:
REMark Preferrably, they were also set via the function set_colours%
:
rem this function needs the extension WL_MK16 (outptr_bin)
:
REMark the colourways% are:
REMark 0= white/green
REMark 1= black/red
REMark 2= white/red
REMark 3= black/green
remark 4-7= use system palettes
:
rem the Global war mycolour_mode% is:
rem 0 = we are in QL mode 4
rem 1 = we are in PAL mode (256 colours)
rem 2 - we are in 24 bit colour mode
rem preferrably, this is set via the function set_colours%
:
  if colourway%>7 or colourway%<0: colourway%=0: REMark must be between 0 & 7
:
rem first make sure that what we request is possible.
rem colourways 4-7 are only possible if we are in 8 or 24 bit colour mode
rem if it is requested in another mode, it is set to 0
:
  if colourway%>3
  rem  if mycolour_mode%< 1
  rem	  colourway%=0
  rem	else
       make_my_palette colourway%-4: rem set colours according to system palette
       return			: rem premature exit
  rem  endif
  endif
:
rem this now is only the old colourways
  select on mycolour_mode%
    =0				: rem QL 4 colours
      SELect ON colourway%
	=0:			: remark white/green
	      menu_pap=white
	      menu_brd=green
	      menu_ink=black
	      menu_bar=wg_striped
	      menu_inv=red
	=1:			: remark black/red
	      menu_pap=black
	      menu_brd=red
	      menu_ink=white
	      menu_bar=br_striped
	      menu_inv=green
	=2:			: remark white/red
	      menu_pap=white
	      menu_brd=red
	      menu_ink=black
	      menu_bar=wr_striped
	      menu_inv=green
	=3:			: remark black/green
	      menu_pap=black
	      menu_brd=green
	      menu_ink=white
	      menu_bar=bg_striped
	      menu_inv=red
      END SELect
    =1				: rem pal colours
      SELect ON colourway%
	=0:			: remark white/green
	      menu_pap=white+256
	      menu_brd=green+256
	      menu_ink=black+256
	      menu_bar=wg_striped+256
	      menu_inv=red +256
	=1:			: remark black/red
	      menu_pap=black+256
	      menu_brd=red  +256
	      menu_ink=white +256
	      menu_bar=br_striped +256
	      menu_inv=green +256
	      omenu_pap=black+256
	=2:			: remark white/red
	      menu_pap=white +256
	      menu_brd=red   +256
	      menu_ink=black +256
	      menu_bar=wr_striped +256
	      menu_inv=green +256
	=3:			: remark black/green
	      menu_pap=black +256
	      menu_brd=green +256
	      menu_ink=white +256
	      menu_bar=bg_striped +256
	      menu_inv=red   +256
      END SELect
    =2				: rem 24 bit colours
      SELect ON colourway%
	=0:			: remark white/green
	      menu_pap=WL_MK16(white)
	      menu_brd=WL_MK16(green)
	      menu_ink=WL_MK16(black)
	      menu_bar=WL_MK16(wg_striped)
	      menu_inv=WL_MK16(red)
	=1:			: remark black/red
	      menu_pap=WL_MK16(black)
	      menu_brd=WL_MK16(red)
	      menu_ink=WL_MK16(white)
	      menu_bar=WL_MK16(br_striped)
	      menu_inv=WL_MK16(green)
	=2:			: remark white/red
	      menu_pap=WL_MK16(white)
	      menu_brd=WL_MK16(red)
	      menu_ink=WL_MK16(black)
	      menu_bar=WL_MK16(wr_striped)
	      menu_inv=WL_MK16(green)
	=3:			: remark black/green
	      menu_pap=WL_MK16(black)
	      menu_brd=WL_MK16(green)
	      menu_ink=WL_MK16(white)
	      menu_bar=WL_MK16(bg_striped)
	      menu_inv=WL_MK16(red)
      END SELect
  end select
:
  make_my_old_palette
:
END DEFine make_colours
:
def proc make_my_palette (cw%)
  sp.winbd	  = hex('0200') : rem Window border
  sp.winbg	  = hex('0201') : rem Window background
  sp.winfg	  = hex('0202') : rem Window foreground
  sp.winmg	  = hex('0203') : rem Window middleground
  sp.titlebg	  = hex('0204') : rem Title background
  sp.titletextbg  = hex('0205') : rem Title text background
  sp.titlefg	  = hex('0206') : rem Title foreground
  sp.litemhigh	  = hex('0207') : rem Loose item highlight
  sp.litemavabg   = hex('0208') : rem Loose item available background
  sp.litemavafg   = hex('0209') : rem Loose item available foreground
  sp.litemselbg   = hex('020a') : rem Loose item selected background
  sp.litemselfg   = hex('020b') : rem Loose item selected foreground
  sp.litemunabg   = hex('020c') : rem Loose item unavailable background
  sp.litemunafg   = hex('020d') : rem Loose item unavailable foreground
  sp.infwinbd	  = hex('020e') : rem Information window border
  sp.infwinbg	  = hex('020f') : rem Information window background
  sp.infwinfg	  = hex('0210') : rem Information window foreground
  sp.infwinmg	  = hex('0211') : rem Information window middleground
  sp.subinfbd	  = hex('0212') : rem Subsidiary information window border
  sp.subinfbg	  = hex('0213') : rem Subsidiary information window background
  sp.subinffg	  = hex('0214') : rem Subsidiary information window foreground
  sp.subinfmg	  = hex('0215') : rem Subsidiary information window middleground
  sp.appbd	  = hex('0216') : rem Application window border
  sp.appbg	  = hex('0217') : rem Application window background
  sp.appfg	  = hex('0218') : rem Application window foreground
  sp.appmg	  = hex('0219') : rem Application window middleground
  sp.appihigh	  = hex('021a') : rem Application window item highlight
  sp.appiavabg	  = hex('021b') : rem Application window item available background
  sp.appiavafg	  = hex('021c') : rem Application window item available foreground
  sp.appiselbg	  = hex('021d') : rem Application window item selected background
  sp.appiselfg	  = hex('021e') : rem Application window item selected foreground
  sp.appiunabg	  = hex('021f') : rem Application window item unavailable background
  sp.appiunafg	  = hex('0220') : rem Application window item unavailable foreground
  sp.scrbar	  = hex('0221') : rem Pan/scroll bar
  sp.scrbarsec	  = hex('0222') : rem Pan/scroll bar section
  sp.scrbararr	  = hex('0223') : rem Pan/scroll bar arrow
  sp.buthigh	  = hex('0224') : rem Button highlight
  sp.butbd	  = hex('0225') : rem Button border
  sp.butbg	  = hex('0226') : rem Button background
  sp.butfg	  = hex('0227') : rem Button foreground
  sp.hintbd	  = hex('0228') : rem Hint border
  sp.hintbg	  = hex('0229') : rem Hint background
  sp.hintfg	  = hex('022a') : rem Hint foreground
  sp.hintmg	  = hex('022b') : rem Hint middleground
  sp.errbg	  = hex('022c') : rem Error message background
  sp.errfg	  = hex('022d') : rem Error message foreground
  sp.errmg	  = hex('022e') : rem Error message middleground
  sp.shaded	  = hex('022f') : rem sp.shaded area
  sp.3ddark	  = hex('0230') : rem Dark 3D border shade
  sp.3dlight	  = hex('0231') : rem Light 3D border shade
  sp.vertfill	  = hex('0232') : rem Vertical area fill
  sp.subtitbg	  = hex('0233')  : rem Subtitle background
  sp.subtittxtbg  = hex('0234')  : rem Subtitle text background
  sp.subtitfg	  = hex('0235')  : rem Subtitle foreground
  sp.mindexbg	  = hex('0236')  : rem Menu index background
  sp.mindexfg	  = hex('0237')  : rem Menu index foreground
  sp.separator	  = hex('0238')  : rem Seperator lines etc.
  if not (is_open(#0) or is_open(#1))
    open#1,'con'
    sp_jobpal -1,cw%
    close#1
  else
    sp_jobpal -1,cw%
  endif
end def make_my_palette
:
def proc make_my_old_palette
rem this translates the colours used in the wdws into 4 colour mode...
  sp.winbd	=	menu_ink   : rem Window border
  sp.winbg	=	menu_pap   : rem Window background
  sp.winfg	=	menu_pap   : rem Window foreground
  sp.winmg	=	menu_pap   : rem Window middleground
  sp.titlebg	=	menu_bar   : rem Title background
  sp.titletextbg=	menu_pap   : rem Title text background
  sp.titlefg	=	menu_ink   : rem Title foreground
  sp.litemhigh	=	menu_brd   : rem Loose item highlight
  sp.litemavabg =	menu_pap   : rem Loose item available background
  sp.litemavafg =	menu_ink   : rem Loex fifiose item available foreground
  sp.litemselbg =	menu_brd   : rem Loose item selected background
  sp.litemselfg =	menu_ink   : rem Loose item selected foreground
  sp.litemunabg =	menu_pap   : rem Loose item unavailable background
  sp.litemunafg =	menu_brd   : rem Loose item unavailable foreground
  sp.infwinbd	=	menu_brd   : rem Information window border
  sp.infwinbg	=	menu_pap   : rem Information window background
  sp.infwinfg	=	menu_ink   : rem Information window foreground
  sp.infwinmg	=	menu_pap   : rem Information window foreground
  sp.subinfbd	=	menu_brd   : rem Information window border (sub)
  sp.subinfbg	=	menu_pap   : rem Information window background
  sp.subinffg	=	menu_ink   : rem Information window foreground
  sp.subinfmg	=	menu_pap   : rem Information window foreground
  sp.appbd	=	menu_brd   : rem Application window border
  sp.appbg	=	menu_pap   : rem Application window background
  sp.appfg	=	menu_ink   : rem Application window foreground
  sp.appmg	=	menu_pap   : rem Application window middleground
  sp.appihigh	=	menu_ink   : rem Application window item highlight
  sp.appiavabg	=	menu_pap   : rem Application window item available background
  sp.appiavafg	=	menu_ink   : rem Application window item available foreground
  sp.appiselbg	=	menu_brd   : rem Application window item selected background
  sp.appiselfg	=	menu_ink   : rem Application window item selected foreground
  sp.appiunabg	=	menu_pap   : rem Application window item unavailable background
  sp.appiunafg	=	menu_brd   : rem Application window item unavailable foreground
  sp.scrbar	=	menu_ink   : rem Pan/scroll bar
  sp.scrbarsec	=	menu_pap   : rem bar section
  sp.scrbararr	=	menu_brd   : rem Pan/scroll bar arrow
  sp.buthigh	=	menu_ink   : rem Button highlight
  sp.butbd	=	menu_brd   : rem Button border
  sp.butbg	=	menu_pap   : rem Button background
  sp.butfg	=	menu_ink   : rem Button foreground
  sp.hintbd	=	menu_brd   : rem Hint border
  sp.hintbg	=	menu_ink   : rem Hint background
  sp.hintfg	=	menu_pap   : rem Hint foreground
  sp.hintmg	=	menu_ink   : rem Hint middleground
  sp.errbg	=	menu_inv   : rem Error message background
  sp.errfg	=	menu_ink   : rem Error message foreground
  sp.errmg	=	menu_ink   : rem Error message middleground
  sp.shaded	=	0	   : rem sp.shaded area
  sp.3ddark	=	0	   : rem Dark 3D border shade
  sp.3dlight	=	white	   : rem Light 3D border shade
  sp.vertfill	=	menu_pap   : rem Vertical area fill
  sp.subtitbg	=	menu_pap   : rem Subtitle background
  sp.subtittxtbg=	menu_pap   : rem Subtitle text background
  sp.subtitfg	=	menu_ink   : rem Subtitle foreground
  sp.mindexbg	=	menu_pap   : rem Menu index background
  sp.mindexfg	=	menu_brd   : rem same,	foreground
  sp.separator	=	menu_brd   : rem Seperator lines etc.
end def make_my_old_palette
:
